// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:dotted_border/dotted_border.dart';
import 'package:flutter/material.dart';
import 'package:wyatt_ui_components/wyatt_ui_components.dart';

class DotterBorderChild extends StatelessWidget {
  const DotterBorderChild({
    required this.style,
    required this.child,
    super.key,
  });

  final FileSelectionButtonStyle style;
  final Widget child;

  @override
  Widget build(BuildContext context) {
    if (style.borderColors != null && style.stroke != null) {
      return DottedBorder(
        padding: EdgeInsets.zero,
        dashPattern: const [5, 5],
        strokeWidth: style.stroke!,
        color: style.borderColors!.color,
        borderType: BorderType.RRect,
        radius:
            style.radius?.resolve(TextDirection.ltr).bottomLeft ?? Radius.zero,
        strokeCap: StrokeCap.square,
        child: child,
      );
    } else {
      return child;
    }
  }
}
